#include <TinyGPS.h> 
#include <Wire.h>

int HMC6352Address = 0x42;
int slaveAddress;
byte headingData[2];
int i, headingValue;
int headingcompass;

const int black = 46;
//const int red = 48;
//const int yellow = 50;
const int green = 52;

int button = 0;
int lastbutton = 0;
int menu = 0;
int b1 = 0;
int b2 = 0;
//int b3 = 0;
//int b4 = 0;
int l = 0;
int j = 0;
int waypoints = 0;
int way = 4;
float flat, flon;
float waylat[4];
float waylon[4];

//motor controller
int motor1Input1 = 8;    // Motor1 inputs connected to pin 4 & 2
int motor1Input2 = 11;
int motor1Pwm= 13;         // Motor1 PWM pin
int motor2Input1= 7;      // Motor2 inputs connected to pin 7 & 5
int motor2Input2= 4;
int motor2Pwm= 2;           // Motor2 PWM pin
int enable1= 10;
int enable2= 5;
int disable1= 12;
int disable2= 3;
int fault1= 9;
int fault2= 6;
int pwm1= 250; //for forward + reverse
int pwm2= 225; //for left + right

TinyGPS gps;

void gpsdump(TinyGPS &gps);
bool feedgps();
void printFloat(double f, int digits = 2);

 

void setup()
{
  Serial.begin(115200);
  Serial1.begin(4800);
  Serial2.begin(4800);
  
  slaveAddress = HMC6352Address >> 1; 
 
  Wire.begin(); 
  
  pinMode(motor1Input1, OUTPUT);      // sets all pins as outputs or inputs
  pinMode(motor1Input2, OUTPUT);
  pinMode(motor2Input1, OUTPUT);
  pinMode(motor2Input2, OUTPUT);
  pinMode(enable1, OUTPUT);
  pinMode(enable2, OUTPUT);
  pinMode(disable1, OUTPUT);
  pinMode(disable2, OUTPUT);
  pinMode(fault1, INPUT);
  pinMode(fault2, INPUT);

  pinMode (black, INPUT);
  pinMode (red, INPUT);
  pinMode (yellow, INPUT);
  pinMode (green, INPUT);
  
  Serial2.print(12,BYTE);
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(1,BYTE);
  Serial2.println(" GPS Rover 1.0. ");
  delay (2000);
  Serial2.print(12,BYTE);
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(1,BYTE);
  Serial2.println("    Starting");
  delay (1000);
  
  //wait for gps to be ready then get a reading
  do
  {
  bool newdata = false;
        unsigned long start = millis();

       // Every fourth of a second we print an update
        while (millis() - start < 400)
          {
            if (feedgps())
            newdata = true;
          }
  
        if (newdata)
          {
            gpsdump(gps);
            delay(400);
          }
  }while(l<1);
  
  //send message to lcd
  Serial2.print(12,BYTE);
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(1,BYTE);
  Serial2.println("press black to");
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(2,BYTE);
  Serial2.println("save waypoint");
  
  delay(1000);
  l=0;
  do
  {
    //check buttons
    b1 = digitalRead(green);
    b2 = digitalRead(black);
    
    //save waypoints
    if (l<way)
    {
    if (b2 == HIGH)
      {
        delay(750);
        bool newdata = false;
        unsigned long start = millis();

       // Every fourth of a second we print an update
        while (millis() - start < 400)
          {
            if (feedgps())
            newdata = true;
          }
  
        if (newdata)
          {
            gpsdump(gps);
            Serial2.print(12,BYTE);
            Serial2.print(254,BYTE);
            Serial2.print(76,BYTE);
            Serial2.print(1,BYTE);
            Serial2.println("saving waypoint");
            waypoints++;
            delay(1000);
            Serial2.print(12,BYTE);
            Serial2.print(254,BYTE);
            Serial2.print(76,BYTE);
            Serial2.print(1,BYTE);
            Serial2.println("waypoint saved");
            delay(1000);
            Serial2.print(12,BYTE);
            Serial2.print(254,BYTE);
            Serial2.print(76,BYTE);
            Serial2.print(1,BYTE);
            Serial2.println("black waypoint");
            Serial2.print(254,BYTE);
            Serial2.print(76,BYTE);
            Serial2.print(2,BYTE);
            Serial2.println("green program");
          }
      }
    }
    
    //if lon and lat arrays are full
    else 
    {
      Serial2.print(12,BYTE);
      Serial2.print(254,BYTE);
      Serial2.print(76,BYTE);
      Serial2.print(1,BYTE);
      Serial2.println("press green to");
      Serial2.print(254,BYTE);
      Serial2.print(76,BYTE);
      Serial2.print(2,BYTE);
      Serial2.println("start program");
      
      delay(50);
    }
  } while(b1 == LOW);
  
l=0;
Serial2.print(12,BYTE);
Serial2.print(254,BYTE);
Serial2.print(76,BYTE);
Serial2.print(1,BYTE);
Serial2.println("program starting"); 
delay(1000);
Serial2.print(12,BYTE);
Serial2.print(254,BYTE);
Serial2.print(76,BYTE);
Serial2.print(1,BYTE);
Serial2.println(" GPS Rover 1.0. ");
}


void loop()
{
  bool newdata = false;
  unsigned long start = millis();

  // Every fourth of a second we print an update
  while (millis() - start < 400)
  {
    if (feedgps())
      newdata = true;
  }
  
  if (newdata)
  {
    Serial.println("Acquired Data");
    Serial.println("-------------");
    gpsdump(gps);
    Serial.println("-------------");
    distance();
    Serial.println("-------------");
    Serial.println();
  }
}

void printFloat(double number, int digits)
{
  // Handle negative numbers
  if (number < 0.0)
  {
     Serial.print('-');
     number = -number;
  }

  // Round correctly so that print(1.999, 2) prints as "2.00"
  double rounding = 0.5;
  for (uint8_t i=0; i<digits; ++i)
    rounding /= 10.0;
  
  number += rounding;

  // Extract the integer part of the number and print it
  unsigned long int_part = (unsigned long)number;
  double remainder = number - (double)int_part;
  Serial.print(int_part);

  // Print the decimal point, but only if there are digits beyond
  if (digits > 0)
    Serial.print("."); 

  // Extract digits from the remainder one at a time
  while (digits-- > 0)
  {
    remainder *= 10.0;
    int toPrint = int(remainder);
    Serial.print(toPrint);
    remainder -= toPrint; 
  } 
}


void gpsdump(TinyGPS &gps)
{
  long lat, lon;
  unsigned long age, date, time, chars;
  unsigned short sentences, failed;
  gps.get_position(&lat, &lon, &age);
  
  Serial.print("Lat/Long(10^-5 deg): "); Serial.print(lat); Serial.print(", "); Serial.print(lon); 
  Serial.print(" Fix age: "); Serial.print(age); Serial.println("ms.");
  
  feedgps(); // If we don't feed the gps during this long routine, we may drop characters and get checksum errors

  gps.f_get_position(&flat, &flon, &age);
  Serial.print("Lat/Long(float): "); printFloat(flat, 5); Serial.print(", "); printFloat(flon, 5);
  Serial.print(" Fix age: "); Serial.print(age); Serial.println("ms.");

  feedgps();
  
  gps.stats(&chars, &sentences, &failed);
  Serial.print("Stats: characters: "); Serial.print(chars); Serial.print(" sentences: "); Serial.print(sentences); Serial.print(" failed checksum: "); Serial.println(failed);

  delay(10);
  waylat[l] = flat;
  waylon[l] = flon;
  l++;
}
*/  
bool feedgps()
{
  while (Serial1.available())
  {
    if (gps.encode(Serial1.read()))
      return true;
  }
  return false;
}

void distance()     //this function will do all the calculations
{  
  float flat1=flat;   // flat1 = our current latitude. flat is from the gps data. 
  float flon1=flon;  // flon1 = our current longitude. flon is from the fps data.
  float dist_calc=0;
  float dist_calc2=0;
  float diflat=0;
  float diflon=0;
  float x2lat=  54.16933;  //enter a latitude point here   this is going to be your waypoint
  float x2lon=  -8.14292;  // enter a longitude point here  this is going to be your waypoint
  int heading;

  //distance formula below. Calculates distance from current location to waypoint
  diflat=radians(x2lat-flat1);  //notice it must be done in radians
  flat1=radians(flat1);    //convert current latitude to radians
  x2lat=radians(x2lat);  //convert waypoint latitude to radians
  diflon=radians((x2lon)-(flon1));   //subtract and convert longitudes to radians
  dist_calc = (sin(diflat/2.0)*sin(diflat/2.0));
  dist_calc2= cos(flat1);
  dist_calc2*=cos(x2lat);
  dist_calc2*=sin(diflon/2.0);                                       
  dist_calc2*=sin(diflon/2.0);
  dist_calc +=dist_calc2;
  dist_calc=(2*atan2(sqrt(dist_calc),sqrt(1.0-dist_calc)));
  dist_calc*=6371000.0; //Converting to meters

  //Bearing
  flon1 = radians(flon1);  //also must be done in radians
  x2lon = radians(x2lon);  //radians duh.
  heading = atan2(sin(x2lon-flon1)*cos(x2lat),cos(flat1)*sin(x2lat)-sin(flat1)*cos(x2lat)*cos(x2lon-flon1)),2*3.1415926535;
  heading = heading*180/3.1415926535;  // convert from radians to degrees
  int head =heading; //make it a integer now
  if(head<0)
  {
    heading+=360;   //if the heading is negative then add 360 to make it positive
  }

  //Compass Reading
  Wire.beginTransmission(slaveAddress);        //the wire stuff is for the compass module
  Wire.send("A");
  Wire.endTransmission();
  delay(10);                  
  Wire.requestFrom(slaveAddress, 2);       
  i = 0;
  while(Wire.available() && i < 2)
  { 
    headingData[i] = Wire.receive();
    i++;
  }
  headingValue = headingData[0]*256 + headingData[1];
  int pracheading = headingValue / 10;      // this is the heading of the compass
  if(pracheading>0)
  {
    headingcompass=pracheading;
  }

  //Turning
  int x4=headingcompass-heading;   //difference of our current heading to our needed bearing
  byte turn;

  if(x4>=-180)
  {
    if(x4<=0)
    {
      turn=8;    //set turn =8 which means "right" 
    }
  }

  if(x4<-180)
  {
    turn=5;      //set turn = 5 which means "left"
  }

  if(x4>=0)
  {
    if(x4<180)
    {
      turn=5;   //set turn = 5 which means "left"
    }
  }

  if(x4>=180)     //set turn =8 which means "right"
  {
    turn=8;
  }

  int hd = headingcompass;

  if(hd==heading)
  {
    turn=3;   //then set turn = 3 meaning go "straight"
  }

  if(turn==3)
  {
    Serial.println("straight");
    
    digitalWrite(enable1, HIGH);
    digitalWrite(disable1, LOW);
    digitalWrite(motor1Input1, LOW);   // Motor1 on
    digitalWrite(motor1Input2, HIGH); 
    analogWrite(motor1Pwm,pwm1);  // Motor1 PWM Pulse
  
    digitalWrite(enable2, HIGH);
    digitalWrite(disable2, LOW);
    digitalWrite(motor2Input1, LOW);   // Motor2 on
    digitalWrite(motor2Input2, HIGH); 
    analogWrite(motor2Pwm,pwm1);  // Motor2 PWM Pulse
  }

  if(turn==8)
  {
    Serial.println("right");
    
    digitalWrite(enable1, HIGH);
    digitalWrite(disable1, LOW);
    digitalWrite(motor1Input1, LOW);   // Motor1 on
    digitalWrite(motor1Input2, HIGH); 
    analogWrite(motor1Pwm,pwm2);  // Motor1 PWM Pulse
  
    digitalWrite(enable2, HIGH);
    digitalWrite(disable2, LOW);
    digitalWrite(motor2Input1, LOW);   // Motor2 on
    digitalWrite(motor2Input2, HIGH); 
    analogWrite(motor2Pwm,pwm2);  // Motor2 PWM Pulse
  }

  if(turn==5)
  {
    Serial.println("left");
    
    digitalWrite(enable1, HIGH);
    digitalWrite(disable1, LOW);
    digitalWrite(motor1Input1, HIGH);   // Motor1 on
    digitalWrite(motor1Input2, LOW); 
    analogWrite(motor1Pwm,pwm2);  // Motor1 PWM Pulse
  
    digitalWrite(enable2, HIGH);
    digitalWrite(disable2, LOW);
    digitalWrite(motor2Input1, HIGH);   // Motor2 on
    digitalWrite(motor2Input2, LOW); 
    analogWrite(motor2Pwm,pwm2);  // Motor2 PWM Pulse
  }

  Serial.println("current heading:");
  Serial.println(headingcompass);

  Serial.println("required heading:");
  Serial.println(heading);   // print the heading.

  Serial.println("distance");
  Serial.println(dist_calc);    //print the distance in meters
}




